From df63243ed3cdbe80872b8d377f98b1f9a5127ec9 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 08 2015 04:59:05 +0000
Subject: [PATCH 102/254] Add a script to populate our db with all users from FAS.


---

diff --git a/populate-all-users.py b/populate-all-users.py
new file mode 100755
index 0000000..401a20e
--- /dev/null
+++ b/populate-all-users.py
@@ -0,0 +1,38 @@
+#!/usr/bin/env python
+""" Populate the hubs db with lots of data from FAS. """
+
+import getpass
+import socket
+import string
+
+import hubs.models
+
+import fedora.client.fas2
+import fedmsg.config
+fedmsg_config = fedmsg.config.load_config()
+
+fasclient = fedora.client.fas2.AccountSystem(
+    username=raw_input('Your FAS username: '),
+    password=getpass.getpass(),
+)
+timeout = socket.getdefaulttimeout()
+socket.setdefaulttimeout(None)
+
+for letter in reversed(sorted(list(set(string.letters.lower())))):
+    session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
+    print "Querying FAS for the %r users.. hang on." % letter
+    request = fasclient.send_request('/user/list',
+                                    req_params={'search': '%s*' % letter},
+                                    auth=True,
+                                    timeout=500)
+    users = request['people']
+
+    for user in users:
+        username = user['username']
+        fullname = user['human_name']
+        openid = '%s.id.fedoraproject.org' % username
+        print "Creating account for %r" % openid
+        hubs.models.User.get_or_create(
+            session, openid=openid, fullname=fullname)
+
+    session.commit()

